#!/usr/bin/python
###########################################################################
##    Author        :  Danial Yousefi
##    Author e-mail :  Da.Yousefi@Gmail.com
###########################################################################
##    Copyright (C) 2009  Danial Yousefi
## 
##    This program is free software: you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation, either version 3 of the License, or
##    any later version.
## 
##    This program is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
## 
##    You should have received a copy of the GNU General Public License
##    along with this program.  If not, see <http://www.gnu.org/licenses/>.
###########################################################################
import os
from bluetooth import *

class BlueLogger:
    def __init__(self):
        self.discovered_addrs=[]
        self.discovered_devs={None: None}
        self.logFile=os.getenv("HOME")+"/.BlueLogger/BlueLogger.log"
        self.time="echo -n \"[$(date +%T)]    \" && echo -n \"[$(date +%T)]    \" >> $HOME/.BlueLogger/BlueLogger.log ;"
        self.noDev="echo \"No device is in range.\" && echo \"No device is in range.\" >> $HOME/.BlueLogger/BlueLogger.log"
        self.newDev="echo \"New device(s) in range:\" &&\
                     echo \"New device(s) in range:\" >> $HOME/.BlueLogger/BlueLogger.log"
    def note_changes(self):
        old_devs = self.discovered_devs
        self.discovered_devs={}
        for addr in self.discovered_addrs:
            if addr in old_devs and old_devs[addr] is not None:
                name = old_devs[addr]
            else:
                name = lookup_name(addr)
            self.discovered_devs[addr] = name
            log = "                  %s   %s"  %( addr, name )
            print log
            fp = open(self.logFile,'a')
            fp.write(log)
            fp.close()
    def has_changes(self):
        changes=False
        self.discovered_addrs = discover_devices()
        for k in self.discovered_addrs:
            if k not in self.discovered_devs:
                os.system(self.time+self.newDev)
                changes=True
                break
        else: ## changes is False
            if self.discovered_devs!={} and self.discovered_addrs==[] :
                os.system(self.time+self.noDev)
                self.discovered_devs={}
                return changes
            for k in self.discovered_devs:
                if k not in self.discovered_addrs:
                    if self.discovered_addrs is None:
                        os.system(self.time+self.noDev)
                    else:
                        os.system(self.time+self.newDev)
                    changes=True
                    break
        return changes

if __name__=='__main__' :
    BL = BlueLogger()
    os.system("mkdir -p $HOME/.BlueLogger ; echo -n > $HOME/.BlueLogger/BlueLogger.log")
    os.system(BL.time+"echo Monitoring... \(Ctrl+D to Stop\) && echo \"Monitoring process started.\" >> $HOME/.BlueLogger/BlueLogger.log")
    try:
       while True:
         while True:
           if BL.has_changes():
             break
         BL.note_changes()
    except KeyboardInterrupt:
       os.system("echo;"+BL.time+"echo \"Monitoring process stopped.\" &&\
                                  echo \"Monitoring process stopped.\" >> $HOME/.BlueLogger/BlueLogger.log")
       exit(0)